<template>
    <div
        :class="{
            'size-lg': size === 'lg',
            'dark': !!dark
        }"
    >
        <label
            v-if="!hideLabel"
            class="block text-sm font-medium capitalize"
            :class="{
                'border-red-500': computedErrors && computedErrors.length,
                'text-red-500': computedErrors && computedErrors.length,
                'font-black': boldLabel,
            }"
        >
            {{ $t(label) }}
        </label>
        <div class="mt-1 relative rounded-sm shadow-sm">
            <div class="flex justify-start">
                <div class="relative w-[74px]">
                    <div
                        class="relative rounded-sm shadow-sm cursor-pointer"
                        @click="openSelect"
                    >
                        <div
                            class="form-control !rounded-tr-none !rounded-br-none contact-select"
                        >
                            <div
                                v-if="selectedCountry"
                                class="flex justify-start space-x-0.5 items-center"
                            >
                                <div
                                    class="f32"
                                >
                                    <div
                                        class="flag"
                                        :class="{
                                            [`${String(selectedCountry.iso2).toLowerCase()}`]: true
                                        }"
                                    />
                                </div>
                                <div>
                                    {{ selectedCountry.ext }}
                                </div>
                            </div>
                            <div
                                v-else
                            >
                                {{ placeholder || $t('please_select') }}
                            </div>
                        </div>
                    </div>
                </div>
                <input
                    :id="id"
                    type="number"
                    :name="contactNumberName"
                    :placeholder="placeholder"
                    :value="numberData"
                    :disabled="disabled"
                    :readonly="readonly"
                    class="form-control flex-1 !appearance-none !rounded-tl-none !rounded-bl-none contact-input"
                    :class="{
                        'border-gray-300': !errors,
                        'border-red-500': errors && errors.length,
                        'text-red-500': errors && errors.length,
                        'opacity-50': disabled || readonly
                    }"
                    @input="numberData = $event.target.value"
                    @keypress="checkForRestriction"
                >
            </div>
        </div>
        <div
            v-if="note && Array.isArray(note)"
        >
            <div
                v-for="(n, i) in note"
                :key="`note-${i}`"
            >
                <div class="font-light font-sm">{{ n }}</div>
            </div>
        </div>
        <div
            v-else-if="note && !Array.isArray(note)"
        >
            <div class="font-light font-sm">{{ note }}</div>
        </div>
        <div
            v-if="computedErrors && computedErrors.length"
        >
            <div
                v-for="(err, i) in computedErrors"
                :key="i"
            >
                <div class="font-light font-sm text-red-500">{{ err }}</div>
            </div>
        </div>
        <teleport
            to="body"
        >
            <panel-modal
                v-if="selectOpened"
                :dark="true"
            >
                <template #body>
                    <div class="flex justify-between space-x-2 px-2 py-4 border-b">
                        <div
                            class="text-lg uppercase"
                        >
                            <div
                                class="font-bold uppercase"
                            >
                                {{ $t(label || name) }}
                            </div>
                            <div
                                v-if="placeholder"
                                class="text-gray-500 text-xs"
                            >
                                {{ placeholder }}
                            </div>
                        </div>
                    </div>
                    <div class="grid grid-cols-1 divide-y">
                        <div
                            v-for="(opt, i) in options"
                            :key="`${contactCountryName}-${i}`"
                            class="cursor-pointer w-full px-2 py-4 flex justify-between space-x-2 items-center"
                            @click="onSelectCountry(opt)"
                        >
                            <div
                                class="flex-1 flex justify-start space-x-2 items-center"
                            >
                                <div
                                    class="f32"
                                >
                                    <div
                                        class="flag"
                                        :class="{
                                            [`${String(countryById[String(opt.value)].iso2).toLowerCase()}`]: true
                                        }"
                                    />
                                </div>
                                <div>
                                    {{ opt.text }}
                                </div>
                            </div>
                            <div
                                v-if="String(countryData) === String(opt.value)"
                                class="text-green-400"
                            >
                                <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                    <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M9 12l2 2 4-4m6 2a9 9 0 11-18 0 9 9 0 0118 0z" />
                                </svg>
                            </div>
                            <div
                                v-else
                            >
                                <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                    <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M9 5l7 7-7 7" />
                                </svg>
                            </div>
                        </div>
                    </div>
                </template>
            </panel-modal>
        </teleport>
    </div>
</template>

<script setup>
import {computed, nextTick, onMounted, ref, watch} from 'vue';
import {useSettingStore} from "~/stores/setting.js";
import PanelModal from "~/components/panel-modal.vue";
import {useI18n} from "vue-i18n";
const props = defineProps({
    id: {
        required: false,
        type: [String, Number],
        default: null,
    },
    label: {
        required: false,
        type: [String, Number],
        default: null,
    },
    boldLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    hideLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    contactCountryName: {
        required: false,
        type: String,
        default: 'contact_country_id',
    },
    contactNumberName: {
        required: false,
        type: String,
        default: 'contact_number',
    },
    placeholder: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    note: {
        required: false,
        type: [String, Number, Array],
        default: null,
    },
    selectValue: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    inputValue: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    errors: {
        required: false,
        type: [Array, Object],
        default: () => [],
    },
    disabled: {
        required: false,
        type: Boolean,
        default: false,
    },
    readonly: {
        required: false,
        type: Boolean,
        default: false,
    },
    size: {
        required: false,
        type: String,
        default: 'md',
    },
    dark: {
        required: false,
        type: Boolean,
        default: false,
    }
});
const $settingStore = useSettingStore();
const $i18n = useI18n();

const countryData = ref(props.selectValue);
const numberData = ref(props.inputValue);
const selectOpened = ref(false);

const emit = defineEmits(['update:selectValue', 'update:inputValue', 'close', 'open']);

const options = computed(() => {
    return $settingStore.extForOptions;
});
const countryById = computed(() => {
    let c = {};
    if (!$settingStore.settings.country) return c;
    $settingStore.settings.country.forEach(r => {
        c[String(r.id)] = r;
    });

    return c;
});
const selectedCountry = computed(() => {
    if (countryData.value) {
        let selected = countryById.value[String(countryData.value)];
        if (selected) {
            return selected;
        }
    }

    return null;
});

const computedErrors = computed(() => {
    if (!props.errors) return null;
    let a = [];
    if (props.errors[props.contactCountryName]) {
        props.errors[props.contactCountryName].forEach(r => {
            a.push(r);
        });
    }

    if (props.errors[props.contactNumberName]) {
        props.errors[props.contactNumberName].forEach(r => {
            a.push(r);
        });
    }
    return a;
});

const openSelect = () => {
    if (!props.readonly && !props.disabled) {
        selectOpened.value = true;
        emit('open');
    }
};
const closeSelect = () => {
    selectOpened.value = false;
    emit('close');
};

const onSelectCountry = (opt) => {
    countryData.value = String(opt.value);
    closeSelect();
}

watch(countryData, (newValue) => {
    emit('update:selectValue', newValue);
});
watch(numberData, (newValue) => {
    emit('update:inputValue', newValue);
});

const checkForRestriction = (event) => {
    let keyCode = (event.keyCode ? event.keyCode : event.which);

    // only allow number
    if (keyCode < 48 || keyCode > 57) {
        event.preventDefault();
    }
};

onMounted(async () => {
    await nextTick(() => {
        if (!countryData.value) {
            if ($settingStore.settings.country && $settingStore.settings.default_country_code) {
                let c = $settingStore.settings.country.find(r => {
                    return String(r.iso2).toUpperCase() === String($settingStore.settings.default_country_code).toUpperCase();
                });

                if (c) {
                    countryData.value = String(c.id);
                    emit('update:selectValue', String(c.id));
                }
            }
        }
    })
});
</script>
